Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.0.Beta5
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.impl.heuristic.selector.value.decorator
Class AbstractCachingValueSelector

    java.lang.Object
      org.optaplanner.core.impl.heuristic.selector.AbstractSelector
          org.optaplanner.core.impl.heuristic.selector.value.AbstractValueSelector
              org.optaplanner.core.impl.heuristic.selector.value.decorator.AbstractCachingValueSelector

All Implemented Interfaces:
  EventListener, SelectionCacheLifecycleListener, Selector, ValueSelector, SolverPhaseLifecycleListener, SolverLifecycleListener

Direct Known Subclasses:
  CachingValueSelector, ShufflingValueSelector

    public abstract class AbstractCachingValueSelector

extends AbstractValueSelector
implements SelectionCacheLifecycleListener

Field Summary
`protected List<Object>` | `cachedValueList`
`protected SelectionCacheType` | `cacheType`
`protected EntityIndependentValueSelector` | `childValueSelector`

Fields inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector
`logger, solverPhaseLifecycleSupport, workingRandom`

Constructor Summary
`AbstractCachingValueSelector(EntityIndependentValueSelector childValueSelector, SelectionCacheType cacheType)`

Method Summary
`void` | `constructCache(DefaultSolverScope solverScope)`
`void` | `disposeCache(DefaultSolverScope solverScope)`
`SelectionCacheType` | `getCacheType()` Unless this selector itself caches, this returns `SelectionCacheType.JUST_IN_TIME`, even if a selector child caches.
`ValueSelector` | `getChildValueSelector()`
`long` | `getSize()`
`long` | `getSize(Object entity)` Similar to `IterableSelector.getSize()`, but requires an entity.
`PlanningVariableDescriptor` | `getVariableDescriptor()`
`boolean` | `isContinuous()` If true, then `Selector.isNeverEnding()` is also true.

Methods inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector
`phaseEnded, phaseStarted, solvingEnded, solvingStarted, stepEnded, stepStarted`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.value.ValueSelector
`iterator`

Methods inherited from interface org.optaplanner.core.impl.heuristic.selector.Selector
`isNeverEnding`

Methods inherited from interface org.optaplanner.core.impl.phase.event.SolverPhaseLifecycleListener
`phaseEnded, phaseStarted, stepEnded, stepStarted`

Methods inherited from interface org.optaplanner.core.impl.solver.event.SolverLifecycleListener
`solvingEnded, solvingStarted`

Field Detail

### childValueSelector

    protected final EntityIndependentValueSelector childValueSelector

### cacheType

    protected final SelectionCacheType cacheType

### cachedValueList

    protected List<Object> cachedValueList

Constructor Detail

### AbstractCachingValueSelector

    public AbstractCachingValueSelector(EntityIndependentValueSelector childValueSelector,
                                        SelectionCacheType cacheType)

Method Detail

### getChildValueSelector

    public ValueSelector getChildValueSelector()

### getCacheType

    public SelectionCacheType getCacheType()

  Description copied from interface: `Selector`
  Unless this selector itself caches, this returns `SelectionCacheType.JUST_IN_TIME`, even if a selector child caches.

  Specified by:
    `getCacheType` in interface `Selector`
  Overrides:
    `getCacheType` in class `AbstractSelector`
  Returns:
    never null

### constructCache

    public void constructCache(DefaultSolverScope solverScope)

  Specified by:
    `constructCache` in interface `SelectionCacheLifecycleListener`

### disposeCache

    public void disposeCache(DefaultSolverScope solverScope)

  Specified by:
    `disposeCache` in interface `SelectionCacheLifecycleListener`

### getVariableDescriptor

    public PlanningVariableDescriptor getVariableDescriptor()

  Specified by:
    `getVariableDescriptor` in interface `ValueSelector`
  Returns:
    never null

### isContinuous

    public boolean isContinuous()

  Description copied from interface: `Selector`
  If true, then `Selector.isNeverEnding()` is also true.

  Specified by:
    `isContinuous` in interface `Selector`
  Returns:
    true if any of the value ranges are continuous (as in for example every double value between 1.2 and 1.4)

### getSize

    public long getSize(Object entity)

  Description copied from interface: `ValueSelector`
  Similar to `IterableSelector.getSize()`, but requires an entity.

  Specified by:
    `getSize` in interface `ValueSelector`
  Parameters:
    `entity` - never null
  Returns:
    the approximate number of elements generated by this `Selector`, always >= 0

### getSize

    public long getSize()

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.0.Beta5
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 JBoss by Red Hat. All Rights Reserved.